/* $Header: /ext/yav/catty/xpx/RCS/cursor.c,v 1.4 1994/01/14 20:32:09 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "extern.h"

#define CURSORN 4
#define BDW 1
#define CURSORW 32
#define CURSORH 18

Window cursorwin[CURSORN];
int cursor_sw[CURSORN];

create_cursor_window(x, y)
{
  int i;

  for (i = 0; i < CURSORN; i++) {
    cursor_sw[i] = 0;
    cursorwin[i] = XCreateSimpleWindow(dsp, win, x, y, CURSORW, CURSORH,
				     BDW, fg, bg);
    XSelectInput(dsp, cursorwin[i],
		 ExposureMask|ButtonPressMask|
		 EnterWindowMask|LeaveWindowMask);
    XMapRaised(dsp, cursorwin[i]);
    x += CURSORW+BDW;
  }
  return 0;
}

close_cursor_window()
{
  int i;
  
  for (i = 0; i < CURSORN; i++)
    XDestroyWindow(dsp, cursorwin[i]);
}

redraw_cursor(n)
{
  char buf[16];

  switch(n) {
  case 0:
    sprintf(buf, "%d", imgofsx);
    break;
  case 1:
    sprintf(buf, "%d", imgofsy);
    break;
  case 2:
    sprintf(buf, "%d", curx);
    break;
  case 3:
    sprintf(buf, "%d", cury);
    break;
  default:
    sprintf(buf, "%d", curz);
    break;
  }
  menuwin_center(cursorwin[n], buf, cursor_sw[n]);
}

cursor_expose(ev)
     XEvent *ev;
{
  int i;
  
  if (ev->xexpose.count == 0) {
    for (i = 0; i < CURSORN; i++) {
      if (ev->xexpose.window == cursorwin[i])
	redraw_cursor(i);
    }
  }
}

cursor_stat_change(i)
{
  cursor_sw[i] = !cursor_sw[i];
  XClearArea(dsp, cursorwin[i], 0, 0, 0, 0, True);
  switch(i) {
  case 0:
    break;
  case 1:
    break;
  }
}

cursor_press(ev)
     XEvent *ev;
{
  int i, oldpal;

  for (i = 0; i < CURSORN; i++) {
    if (ev->xbutton.window == cursorwin[i]) {
      cursor_stat_change(i);
      break;
    }
  }
}

cursor_enter(ev)
     XEvent *ev;
{
  int i;

  for (i = 0; i < CURSORN; i++) {
    if (ev->xcrossing.window == cursorwin[i])
      menuwin_highlight(cursorwin[i], cursor_sw[i]);
  }
}

/* End of file */
