/* $Header: /ext/yav/catty/xpx/RCS/grid.c,v 1.3 1994/01/13 17:16:27 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "extern.h"

#define BDW 1
#define GRIDN 3
#define GRIDW 24
#define GRIDH 16
#define MAXGRID 32

static Window gridwin[GRIDN];
static int grid_sw[GRIDN];

create_grid_window(x, y)
{
  
  int i;

  for (i = 0; i < GRIDN; i++) {
    grid_sw[i] = 0;
    gridwin[i] = XCreateSimpleWindow(dsp, win, x, y, GRIDW, GRIDH,
				     BDW, fg, bg);
    XSelectInput(dsp, gridwin[i],
		 ExposureMask|ButtonPressMask|ButtonReleaseMask|
		 EnterWindowMask|LeaveWindowMask);
    XMapRaised(dsp, gridwin[i]);
    x += GRIDW+BDW;
  }
}

close_grid_window()
{
  int i;
  
  for (i = 0; i < GRIDN; i++)
    XDestroyWindow(dsp, gridwin[i]);
}

redraw_gridmenu(n)
{
  char buf[16];
  static char *gridstr[GRIDN] = {"<<", NULL, "<<"};

  if (n == 1) {
    sprintf(buf, "%d", grid_size);
    menuwin_center(gridwin[n], buf, grid_sw[n]);
  } else {
    menuwin_center(gridwin[n], gridstr[n], grid_sw[n]);
  }
}

grid_expose(ev)
     XEvent *ev;
{
  int i;
  
  if (ev->xexpose.count == 0) {
    for (i = 0; i < GRIDN; i++) {
      if (ev->xexpose.window == gridwin[i])
	redraw_gridmenu(i);
    }
  }
}

grid_in()
{
  if (grid_size < MAXGRID) {
    ++grid_size;
    XClearArea(dsp, gridwin[1], 0, 0, 0, 0, True);
    if (grid_mode)
      img_expose(0, 0, imgwinwidth, imgwinheight);
  }
}

grid_out()
{
  if (grid_size > 1) {
    --grid_size;
    XClearArea(dsp, gridwin[1], 0, 0, 0, 0, True);
    if (grid_mode)
      img_expose(0, 0, imgwinwidth, imgwinheight);
  }
}

grid_press(ev)
     XEvent *ev;
{
  int i, oldpal;

  for (i = 0; i < GRIDN; i++) {
    if (ev->xbutton.window == gridwin[i]) {
      switch(i) {
      case 0:
	grid_out();
	break;
      case 1:
	grid_sw[i] = !grid_sw[i];
	if (grid_sw[i])
	  grid_mode = 1;
	else
	  grid_mode = 0;
	img_expose(0, 0, imgwinwidth, imgwinheight);
	break;
      case 2:
	grid_in();
	break;
      }
      break;
    }
  }
}

grid_enter(ev)
     XEvent *ev;
{
  int i;

  for (i = 0; i < GRIDN; i++) {
    if (ev->xcrossing.window == gridwin[i])
      menuwin_highlight(gridwin[i], grid_sw[i]);
  }
}

/* End of file */
