/* $Header: /ext/yav/catty/xpx/RCS/info.c,v 1.1 1994/01/17 22:19:08 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "extern.h"

#define BDW 1

#define INFOWIDTH 480
#define INFOHEIGHT 140
#define INFOMENUX ((INFOWIDTH-INFOMENUW)/2)
#define INFOMENUY (INFOHEIGHT-INFOMENUH-BDW*2-4)
#define INFOMENUW 50
#define INFOMENUH 20
#define INFOLINESPACE 16

static Window infowin;
static int infowin_opened = 0;
static Window infomenuwin;

create_info_window(x, y)
{
  int i;
  XSizeHints hint;
  char buf[256];

  if (infowin_opened) {
    XMapWindow(dsp, infowin);
    return 1;
  }
  hint.x = x; hint.y = y;
  hint.width = INFOWIDTH; hint.height = INFOHEIGHT;
  hint.flags = PPosition|PSize;
  infowin = XCreateSimpleWindow(dsp, DefaultRootWindow(dsp), hint.x, hint.y,
				hint.width, hint.height, BDW, fg, bg);
  sprintf(buf, "%s info", myname);
  XSetStandardProperties(dsp, infowin, buf, buf, None, NULL, NULL, &hint);
  XSelectInput(dsp, infowin, ExposureMask);
  XMapRaised(dsp, infowin);

  infomenuwin = XCreateSimpleWindow(dsp, infowin, INFOMENUX, INFOMENUY,
				    INFOMENUW, INFOMENUH,
				    BDW, fg, bg);
  XSelectInput(dsp, infomenuwin,
	       ButtonPressMask|ExposureMask|EnterWindowMask|LeaveWindowMask);
  XMapRaised(dsp, infomenuwin);
  infowin_opened = 1;
  return 0;
}

unmap_info_window()
{
  XUnmapWindow(dsp, infowin);
}

close_info_window()
{
  int i;

  if (!infowin_opened)
    return;
  infowin_opened = 0;
  XDestroyWindow(dsp, infomenuwin);
  XDestroyWindow(dsp, infowin);
}


redraw_info()
{
  int y;
  char buf[256];

  y = 0;
  y += INFOLINESPACE;
  sprintf(buf, "* %s %s *", myname, rcsrev);
  XDrawString(dsp, infowin, gc0, 4, y, buf, strlen(buf));
  y += INFOLINESPACE;
  sprintf(buf, "image file : %s", imgfilename);
  XDrawString(dsp, infowin, gc0, 4, y, buf, strlen(buf));
  y += INFOLINESPACE;
  sprintf(buf, "color file : %s", colfilename);
  XDrawString(dsp, infowin, gc0, 4, y, buf, strlen(buf));
  y += INFOLINESPACE;
  sprintf(buf, "size : %d x %d", imgfilew, imgfileh);
  XDrawString(dsp, infowin, gc0, 4, y, buf, strlen(buf));
  y += INFOLINESPACE;
  sprintf(buf, "color : %d", alloced_color);
  XDrawString(dsp, infowin, gc0, 4, y, buf, strlen(buf));
}

update_infowin()
{
  if (infowin_opened)
    XClearArea(dsp, infowin, 0, 0, 0, 0, True);
}

info_expose(ev)
     XEvent *ev;
{
  int i;

  if (!infowin_opened)
    return;
  if (ev->xexpose.count != 0)
    return;
  if (ev->xexpose.window == infowin) {
    redraw_info();
    return;
  }
  if (ev->xexpose.window == infomenuwin) {
    menuwin_center(infomenuwin, "OK", 0);
    return;
  }
}


info_press(ev)
     XEvent *ev;
{
  int i, oldsel;

  if (!infowin_opened)
    return;
  if (ev->xbutton.window == infomenuwin) {
    menu_stat_change(2);
    return;
  }
}

info_enter(ev)
     XEvent *ev;
{
  int i;

  if (!infowin_opened)
    return;
  if (ev->xcrossing.window == infomenuwin) {
    menuwin_highlight(infomenuwin, 0);
    return;
  }
}

/* End of file */
