/* $Header: /ext/yav/catty/xpx/RCS/menu.c,v 1.8 1994/01/17 22:19:08 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "extern.h"

#define MAXMENU 4
#define BDW 1
#define MENUW 52
#define MENUH 18

static Window menuwin[MAXMENU];
static int menu_sw[MAXMENU];

create_menu_window(x, y)
{
  int i;

  for (i = 0; i < MAXMENU; i++) {
    menu_sw[i] = 0;
    menuwin[i] = XCreateSimpleWindow(dsp, win, x, y, MENUW, MENUH,
				     BDW, fg, bg);
    XSelectInput(dsp, menuwin[i],
		 ExposureMask|ButtonPressMask|ButtonReleaseMask|
		 EnterWindowMask|LeaveWindowMask);
    XMapRaised(dsp, menuwin[i]);
    x += MENUW+BDW;
  }
  return 0;
}

close_menu_window()
{
  int i;
  
  for (i = 0; i < MAXMENU; i++)
    XDestroyWindow(dsp, menuwin[i]);
}

redraw_menu(n)
{
  static char *menustr[4] = {"Quit", "File", "Info", "----"};

  menuwin_center(menuwin[n], menustr[n], menu_sw[n]);
}

menu_expose(ev)
     XEvent *ev;
{
  int i;
  
  if (ev->xexpose.count == 0) {
    for (i = 0; i < MAXMENU; i++) {
      if (ev->xexpose.window == menuwin[i])
	redraw_menu(i);
    }
  }
}

menu_stat_change(i)
{
  menu_sw[i] = !menu_sw[i];
  XClearArea(dsp, menuwin[i], 0, 0, 0, 0, True);
  switch(i) {
  case 0:
    sw_quit = 1;
    break;
  case 1:
    if (menu_sw[i])
      create_file_window(500, 300);
    else
      unmap_file_window();
    break;
  case 2:
    if (menu_sw[i])
      create_info_window(500, 300);
    else
      unmap_info_window();
    break;
  }
}

menu_press(ev)
     XEvent *ev;
{
  int i, oldpal;

  for (i = 0; i < MAXMENU; i++) {
    if (ev->xbutton.window == menuwin[i]) {
      menu_stat_change(i);
      break;
    }
  }
}

menu_enter(ev)
     XEvent *ev;
{
  int i;

  for (i = 0; i < MAXMENU; i++) {
    if (ev->xcrossing.window == menuwin[i])
      menuwin_highlight(menuwin[i], menu_sw[i]);
  }
}

/* End of file */
