/* $Header: /ext/yav/catty/xpx/RCS/sub.c,v 1.3 1994/01/13 17:16:27 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "extern.h"

draw_hbox_gc(w, g)
     Window w;
     GC g;
{
  XWindowAttributes attr;
  
  XGetWindowAttributes(dsp, w, &attr);
  XDrawRectangle(dsp, w, g, 0, 0, attr.width-1, attr.height-1);
}

menuwin_highlight(wd, sw)
     Window wd;
     int sw;
{
  draw_hbox_gc(wd, sw?gc1:gc0);
}

menuwin_normal(wd, str)
     Window wd;
     char *str;
{
  int len, w, y;
  int dir, asc, des;
  XWindowAttributes attr;
  XCharStruct overall;
  
  XGetWindowAttributes(dsp, wd, &attr);
  len = strlen(str);
  w = XTextWidth(fs0, str, len);
  XTextExtents(fs0, str, 0, &dir, &asc, &des, &overall);
  y = attr.height - (attr.height-(asc+des))/2 - des;
  XDrawString(dsp, wd, gc0, (attr.width-w)/2, y, str, len);
}

menuwin_select(wd, str)
     Window wd;
     char *str;
{
  int len, w, y;
  int dir, asc, des;
  XWindowAttributes attr;
  XCharStruct overall;
  
  XGetWindowAttributes(dsp, wd, &attr);
  len = strlen(str);
  w = XTextWidth(fs1, str, len);
  XTextExtents(fs1, str, 0, &dir, &asc, &des, &overall);
  y = attr.height - (attr.height-(asc+des))/2 - des;
  XFillRectangle(dsp, wd, gc0, 0, 0, attr.width, attr.height);
  XDrawString(dsp, wd, gc1, (attr.width-w)/2, y, str, len);
}

menuwin_center(wd, str, sw)
     Window wd;
     char *str;
     int sw;
{
  if (sw)
    menuwin_select(wd, str);
  else
    menuwin_normal(wd, str);
}

menuwin_lnormal(wd, str)
     Window wd;
     char *str;
{
  XWindowAttributes attr;
  
  XGetWindowAttributes(dsp, wd, &attr);
  XDrawString(dsp, wd, gc0, 2, attr.height-5, str, strlen(str));
}

menuwin_lselect(wd, str)
     Window wd;
     char *str;
{
  XWindowAttributes attr;
  
  XGetWindowAttributes(dsp, wd, &attr);
  XFillRectangle(dsp, wd, gc0, 0, 0, attr.width, attr.height);
  XDrawString(dsp, wd, gc1, 2, attr.height-5, str, strlen(str));
}

menuwin_left(wd, str, sw)
     Window wd;
     char *str;
     int sw;
{
  if (sw)
    menuwin_lselect(wd, str);
  else
    menuwin_lnormal(wd, str);
}

/* End of file */
