/* $Header: /ext/yav/catty/xpx/RCS/zoom.c,v 1.2 1994/01/13 17:16:27 yav Exp $
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>

#include "xpx.h"
#include "extern.h"

#define BDW 1
#define ZOOMN 3
#define ZOOMW 24
#define ZOOMH 16

static Window zoomwin[ZOOMN];
static int zoom_sw[ZOOMN];

create_zoom_window(x, y)
{
  
  int i;

  for (i = 0; i < ZOOMN; i++) {
    zoom_sw[i] = 0;
    zoomwin[i] = XCreateSimpleWindow(dsp, win, x, y, ZOOMW, ZOOMH,
				     BDW, fg, bg);
    XSelectInput(dsp, zoomwin[i],
		 ExposureMask|ButtonPressMask|ButtonReleaseMask|
		 EnterWindowMask|LeaveWindowMask);
    XMapRaised(dsp, zoomwin[i]);
    x += ZOOMW+BDW;
  }
}

close_zoom_window()
{
  int i;
  
  for (i = 0; i < ZOOMN; i++)
    XDestroyWindow(dsp, zoomwin[i]);
}

redraw_zoommenu(n)
{
  char buf[16];
  static char *zoomstr[ZOOMN] = {"<<", NULL, "<<"};

  if (n == 1) {
    sprintf(buf, "%d", zoomfactor);
    menuwin_center(zoomwin[n], buf, zoom_sw[n]);
  } else {
    menuwin_center(zoomwin[n], zoomstr[n], zoom_sw[n]);
  }
}

zoom_expose(ev)
     XEvent *ev;
{
  int i;
  
  if (ev->xexpose.count == 0) {
    for (i = 0; i < ZOOMN; i++) {
      if (ev->xexpose.window == zoomwin[i])
	redraw_zoommenu(i);
    }
  }
}

zoom_in()
{
  if (zoomfactor < MAXZOOM) {
    ++zoomfactor;
    XClearArea(dsp, zoomwin[1], 0, 0, 0, 0, True);
    image_update_all();
  }
}

zoom_out()
{
  if (zoomfactor > 1) {
    --zoomfactor;
    XClearArea(dsp, zoomwin[1], 0, 0, 0, 0, True);
    image_update_all();
  }
}

zoom_press(ev)
     XEvent *ev;
{
  int i, oldpal;

  for (i = 0; i < ZOOMN; i++) {
    if (ev->xbutton.window == zoomwin[i]) {
      switch(i) {
      case 0:
	zoom_out();
	break;
      case 2:
	zoom_in();
	break;
      }
      break;
    }
  }
}

zoom_enter(ev)
     XEvent *ev;
{
  int i;

  for (i = 0; i < ZOOMN; i++) {
    if (ev->xcrossing.window == zoomwin[i])
      menuwin_highlight(zoomwin[i], zoom_sw[i]);
  }
}

/* End of file */
